unit XMLShared;
interface
uses XMLIntf,XMLDoc,xmldom,variants;

const TagsSeparator='/';
 TagsS=TagsSeparator;

//function VarToStr(v:OLEVariant):string;

function GetRootNode(Doc:IXMLDocument;Name:string):IXMLNode;

function GetNodeByLongName(Root:IXMLNode;LongName:string):IXMLNode;
function GetTextByLongName(Root:IXMLNode;LongName:string):string;
function GetBool(Node:IXMLNode):boolean;

function GetLongNameByNode(Root:IXMLNode;Node:IXMLNode):string;
procedure SetTextByLongName(Root:IXMLNode;LongName:string;Text:widestring);

procedure DeleteNodeByLongName(Root:IXMLNode;LongName:string);
procedure DeleteNode(XMLNode:IXMLNode);

function GetDOMNodeSelect(const Node: IXMLNode): IDOMNodeSelect;

function PutNodes(const Source:string;const Root:IXMLNode):string;

implementation
Uses SysUtils,shared;

{function VarToStr(v:OLEVariant):string;
begin
 if v=null then result:='' else result:=v;
end;}

function GetRootNode(Doc:IXMLDocument;Name:string):IXMLNode;
var i:integer;
begin
 Doc.Active:=true;
 result:=nil;
 if doc.ChildNodes.Count=0 then exit;
 i:=0;
 repeat
  result:=Doc.ChildNodes[i];
  inc(i);
 until (result.NodeName=Name)or(i>=Doc.ChildNodes.Count);
 if result.NodeName<>Name then result:=nil;
end;

function GetNodeByLongName(Root:IXMLNode;LongName:string):IXMLNode;
var p:integer;
begin
 if doNodeAutoCreate in Root.OwnerDocument.Options then
  while (LongName<>'')and(root<>nil) do begin
   p:=pos(TagsS,LongName);
   if p=0 then p:=maxint-1;
   if (length(LongName)>0)and(LongName[1]='@') then
    root:=root.AttributeNodes.GetNode(copy(LongName,2,p-1))
   else
    root:=root.ChildNodes.GetNode(copy(LongName,1,p-1));
   LongName:=copy(LongName,p+1,maxint);
  end
 else
  while (LongName<>'')and(root<>nil) do begin
   p:=pos(TagsS,LongName);
   if p=0 then p:=maxint-1;
   if (length(LongName)>0)and(LongName[1]='@') then
    root:=root.AttributeNodes.FindNode(copy(LongName,2,p-1))
   else
    root:=root.ChildNodes.FindNode(copy(LongName,1,p-1));
   LongName:=copy(LongName,p+1,maxint);
  end;
 result:=root;
end;

function GetTextByLongName(Root:IXMLNode;LongName:string):string;
var
 t:IXMLNode;
 opt:TXMLDocOptions;
begin
 opt:=Root.OwnerDocument.Options;
 Root.OwnerDocument.Options:=opt-[doNodeAutoCreate];
 t:=GetNodeByLongName(Root,LongName);
 if t=nil then result:='' else result:=VarToStr(t.Text);
 Root.OwnerDocument.Options:=opt;
end;

function GetBool(Node:IXMLNode):boolean;
begin
 result:=false;
 if Node=nil then exit;
 if Node.Text='-1' then result:=true;
end;

function GetLongNameByNode(Root:IXMLNode;Node:IXMLNode):string;
begin
 result:='';
 while (Node<>Root)and(Node.ParentNode<>nil) do begin
  Result:=Node.NodeName+TagsS+result;
  Node:=Node.ParentNode;
 end;
 Result:=Copy(Result,0,length(result)-1);
end;

procedure SetTextByLongName(Root:IXMLNode;LongName:string;Text:widestring);
var p:integer;
    t:boolean;
begin
 t:=not(doNodeAutoCreate in Root.OwnerDocument.Options);
 Root.OwnerDocument.Options:=Root.OwnerDocument.Options+[doNodeAutoCreate];
 p:=pos('@',LongName);
 if p=0 then GetNodeByLongName(Root,LongName).Text:=Text
  else GetNodeByLongName(Root,copy(LongName,0,p-2)).Attributes[copy(LongName,p+1,maxint)]:=Text;
 if t then Root.OwnerDocument.Options:=Root.OwnerDocument.Options-[doNodeAutoCreate];
end;

function GetIndexByNode(XMLNode:IXMLNode):integer;
var i:integer;
    t:IXMLNode;
begin
 result:=-1;
 t:=XMLNode.ParentNode;
 for i:=0 to t.ChildNodes.Count-1 do
  if t.ChildNodes[i]=XMLNode then result:=i;
end;

procedure DeleteNode(XMLNode:IXMLNode);
var t:IXMLNode;
begin
 t:=XMLNode.ParentNode;
 t.ChildNodes.Delete(GetIndexByNode(XMLNode));
end;

procedure DeleteNodeByLongName(Root:IXMLNode;LongName:string);
var
 p,i:integer;
 t:IXMLNode;
begin
 if LongName='' then exit;
 if LongName[length(LongName)]=TagsS then SetLength(LongName,length(LongName)-1);
 p:=pos('@',LongName);
 if p=0 then begin
  for i:=1 to length(LongName)-1 do
   if LongName[i]=TagsS then p:=i;
  t:=GetNodeByLongName(Root,copy(LongName,0,p-1));
  LongName:=copy(LongName,p+1,maxint);
  if t<>nil then t.ChildNodes.Delete(LongName);
 end else begin
  t:=GetNodeByLongName(Root,copy(LongName,0,p-1));
  if t<>nil then t.AttributeNodes.Delete(copy(LongName,p+1,maxint));
 end;
end;

function GetDOMNodeSelect(const Node: IXMLNode): IDOMNodeSelect;
begin
  if not Supports(Node.DOMNode, IDOMNodeSelect, Result) then
    raise DOMException.Create('No XPaths');
end;

function PutNodes(const Source:string;const Root:IXMLNode):string;
var ps,ls:integer;
    t:integer;
    vn:string;
begin
 result:='';
 ls:=length(Source);
 ps:=1;
 while ps<ls do begin
  if CharInSet(Source[ps], [#9,#10,#13,' ','''']) then begin
   result:=result+pqstrtostr(Source,ps);
  end else begin
   t:=ps; while (Source[ps]<>'''')and(ps<ls) do inc(ps);
   vn:=copy(Source,t,ps-t);
   result:=result+GetTextByLongName(Root,vn);
  end;
 end;
end;

end.